***********************************************************
#DEFINE ErrOK 0
#DEFINE ErrOther -1

#DEFINE CRLF  CHR(13)+CHR(10)

#DEFINE _ID_Max             -2000000001


#DEFINE _JC_GS_None             0 && 
#DEFINE _JC_GS_Connect          1 && Connect
#DEFINE _JC_GS_Establish        2 
#DEFINE _JC_GS_Join             3 
#DEFINE _JC_GS_Presence         4 
#DEFINE _JC_GS_Joined           5 
#DEFINE _JC_GS_Disconnecting    6
#DEFINE _JC_GS_Disconnecting_CF 7
#DEFINE _JC_GS_Disconnecting_LC 8
#DEFINE _JC_GS_Reconnect        9
#DEFINE _JC_GS_Restart         10
#DEFINE _JC_GS_Error           11
#DEFINE _JC_GS_Authorisation   12
#DEFINE _JC_GS_Handshake       13



#DEFINE _JC_DataSystem     50
#DEFINE _JC_DataNext      -1

#DEFINE _JC_E_pr        0 && Presence
#DEFINE _JC_E_iq        1 && Info/Query
#DEFINE _JC_E_msg       2 && Message
#DEFINE _JC_E_stream    3 && Stream
#DEFINE _JC_E_handshake 4 && Handshake

#DEFINE _JC_P_Failed    -1 && Chyba
#DEFINE _JC_P_Processed  0 && Zpracovno
#DEFINE _JC_P_Free       1 && Voln
#DEFINE _JC_P_Trackly    2 && Sledovan


#DEFINE sckClosed             0 &&  Default. Closed 
#DEFINE sckOpen               1 &&  Open 
#DEFINE sckListening          2 &&  Listening 
#DEFINE sckConnectionPending  3 &&  Connection pending 
#DEFINE sckResolvingHost      4 &&  Resolving host 
#DEFINE sckHostResolved       5 &&  Host resolved 
#DEFINE sckConnecting         6 &&  Connecting 
#DEFINE sckConnected          7 &&  Connected 
#DEFINE sckClosing            8 &&  Peer is closing the connection 
#DEFINE sckError              9 &&  Error 

#DEFINE _O_WRONLY       0x0001  && open for writing only 
#DEFINE _O_CREAT        0x0100  && create and open file 

#DEFINE _LK_UNLCK    0 && unlock the file region
#DEFINE _LK_LOCK    1 && lock the file region 
#DEFINE _LK_NBLCK    2 && non-blocking lock 
#DEFINE _LK_RLCK    3 && lock for writing 
#DEFINE _LK_NBRLCK    4 && non-blocking lock for writing 

#DEFINE _S_IREAD        0000400  &&  read permission, owner 
#DEFINE _S_IWRITE       0000200   && write permission, owner 


* Message type
#DEFINE _jbm_Normal    0
#DEFINE _jbm_Chat      1
#DEFINE _jbm_GroupChat 2

