EXTERNAL ARRAY laSA
EXTERNAL ARRAY laCOV

************************************************************************************
** Vrt pozici etzce v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_Ex(lcSource,lcString,liStart,liEnd) && Vrt pozici etzce v etzci od urit pozice (vyhledv zleva)
* @lcSource - Zdrojov etzec
* @lcString - Hledan etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liLen=LEN(m.lcString)
liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString,0,m.liStart)) && Vra poten pozici
ENDPROC

*************************************
* Najde oddlova (zprava)
*************************************
PROCEDURE RFindMDSC(lcSource,lcOdd,liStart,liEnd) && Najde oddlova (zprava)
* @lcSource - Zdrojov etzec
* lcOdd     - Oddlova co se m hledat
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

LOCAL liFlag,lcChar,liEndFlag

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="]",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcOdd=";",0,;
       IIF(m.lcChar=')',6,0)))))

liEnd=IIF(PCOUNT()=4,m.liEnd,1)

DO WHILE m.liStart>=m.liEnd

   IF m.liFlag=0 AND m.lcChar=m.lcOdd
      RETURN m.liStart
   ENDIF

   liStart=liStart-1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="[",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar='(',0,;
          IIF(m.lcChar="]",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcOdd=";",0,;
          IIF(m.lcChar=')',6,m.liFlag)))))))))
ENDDO

RETURN 0 && Vra, e nic nenael
ENDPROC

*************************************
* Najde oddlova (zleva)
*************************************
PROCEDURE FindMDSC(lcSource,lcOdd,liStart,liEnd) && Najde oddlova (zleva)
* @lcSource - Zdrojov etzec
* lcOdd     - Oddlova co se m hledat
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

LOCAL liFlag,lcChar,liEndFlag

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="[",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcOdd=";",0,;
       IIF(m.lcChar='(',6,0)))))

liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))

DO WHILE m.liStart<=m.liEnd

   IF m.liFlag=0 AND m.lcChar=m.lcOdd
      RETURN m.liStart
   ENDIF

   liStart=m.liStart+1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="]",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar=')',0,;
          IIF(m.lcChar="[",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcOdd=";",0,;
          IIF(m.lcChar='(',6,m.liFlag)))))))))
ENDDO

RETURN 0 && Vra, e nic nenael
ENDPROC


************************************************************
*
***********************************************************
PROCEDURE DT2Stamp(ltTime) && Pevede datum a as na timestamp pro jabber
* ltTime - datum a as pro pevod
LOCAL lcPom
lcPom=TTOC(m.ltTime,1)
RETURN LEFT(m.lcPom,8)+"T"+SUBST(m.lcPom,9,2)+":"+SUBST(m.lcPom,11,2)+":"+RIGHT(m.lcPom,2)
ENDPROC

************************************************************
*
***********************************************************
PROCEDURE Stamp2DT(lcStamp) && Pevede timestamp jabberu na datum a as
* lcStamp - timestamp pro pevod
RETURN CTOT("^"+LEFT(m.lcStamp,4)+"-"+SUBST(m.lcStamp,5,2)+"-"+SUBST(m.lcStamp,7,2)+" "+SUBST(m.lcStamp,10))
ENDPROC

************************************************************
*
***********************************************************
PROCEDURE AWords(lcRow,lcSep,laWords) && Nate slova do matice
* lcRow   - Zdrojov text
* lcSep   - Oddlova
*@laWords - Vstupn matice
LOCAL lii,liCount,lcWord
liCount=0
lcWord=GetWordEx(@m.lcRow,@m.lcSep,1,LEN(m.lcRow))
DO WHILE !EMPTY(m.lcWord)
   liCount=m.liCount+1
   DIME laWords(m.liCount)
   laWords(m.liCount)=m.lcWord
   lcWord=GetWordEx(@m.lcRow,@m.lcSep,1,LEN(m.lcRow))
ENDDO
RETURN m.liCount
ENDPROC
************************************************************

************************************************************
*
***********************************************************
PROCEDURE CopyArrayU(laSA,laDA) && Kopie matice a pevod na velk psmena
* laSA - Zdrojov matice
* laDA - Clov matice
LOCAL lii
DIME laDA(ALEN(laSA))
FOR lii=1 TO ALEN(laSA)
    laDA(m.lii)=UPPER(laSA(m.lii))
NEXT
ENDPROC
************************************************************


*************************************
* Vrt slovo, ignoruje oddlovae v etzci
*************************************
PROCEDURE GetWordEx(lcSource,lcOdd,liStart,liEnd) &&  && Vrt 1. slovo z etzce, ignoruje slova v oddlovach
*@lcSource - Zdrojov etzec
*@lcOdd    - Oddlova co se m hledat
* liStart  - Startovac pozice pro hledn
* liEnd    - Konen pozice pro hledn

LOCAL liFlag,lcChar,lcPom,liWord,liOld

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="[",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcChar='(',6,0))))

liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
liOld=m.liStart

liWord=0
DO WHILE m.liStart<=m.liEnd
   IF m.liFlag=0 AND ATC(m.lcChar,m.lcOdd)>0
      IF m.liWord=2
         lcPom=SUBST(m.lcSource,m.liOld,m.liStart-m.liOld)
         lcSource=SUBST(m.lcSource,m.liStart)
         RETURN m.lcPom
      ELSE
         liOld=m.liOld+1
      ENDIF
   ENDIF

   liWord=IIF(ATC(m.lcChar,m.lcOdd)>0,1,2)
   liStart=m.liStart+1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="]",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar=')',0,;
          IIF(m.lcChar="[",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcChar='(',6,m.liFlag))))))))
          
ENDDO
IF m.liWord>0
   lcPom=SUBST(m.lcSource,m.liOld)
   lcSource=""
   RETURN m.lcPom
ELSE
   RETURN "" && Vra, e nic nenael
ENDIF
ENDPROC


***********************************************************
* MJ 2003-12-23
***********************************************************
PROCEDURE StrTranHTMLString(lcString) && Pevod zakzanch znak na entity
* lcString - etzec pro pevod
RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(;
       m.lcString,"&","&amp;"),">","&gt;"),"<","&lt;"),'"',"&#34;"),"'","&#39;"),CHR(9),"&#9;")
ENDPROC

***********************************************************
* MJ 2003-12-23
***********************************************************
PROCEDURE HTMLStringTranStr(lcString) && Pevod entit na zakzan znaky
* lcString - etzec pro pevod
RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(;
       m.lcString,"&gt;",">"),"&lt;","<"),"&#34;",'"'),"&#39;","'"),"&#9;",CHR(9)),"&amp;","&")
ENDPROC


********************************************
*
*********************************************
PROCEDURE BASETo64(lcString) && Pevod etzce na base64
* lcString - etzec pro pevod
LOCAL lii,lcChar,lcData,liLen,liy
lcData=""
liLen=LEN(m.lcString)
liy=0
FOR lii = 1 TO m.liLen
    liy=m.liy+1
    m.lcChar = SUBST(m.lcString, m.lii)
    IF !((ASC(m.lcChar) >= 33 AND ASC(m.lcChar) <= 60) OR (ASC(m.lcChar) >= 62 AND ASC(m.lcChar) <= 126)) OR (ASC(m.lcChar) = 46)
       lcData=m.lcData+"=" + SUBSTR(TRANSFORM(ASC(m.lcChar), '@0'), LEN(TRANSFORM(ASC(m.lcChar), '@0'))-1)
    ENDIF

	FOR m.liy = 1 TO 74
		IF m.lii>m.liLen
		   EXIT
		ENDIF
	NEXT
	IF m.lii<=m.liLen
       lcData=m.lcData+"="
	ELSE
       EXIT
	ENDIF
NEXT
RETURN m.lcData
ENDPROC

********************************************
*
*********************************************
PROCEDURE DT2CL(ltDT) && Pevod vtein na znakov vyjden
* ltDT - Vteiny
LOCAL liDayS,liMonthS,liYearS,liHourS,liMinS,;
      lii,liy,lcDay,lcMonth,lcYear,lcHour,lcMin,lcSec

liMinS=60
liHourS=m.liMinS*60
liDayS=m.liHourS*24
liMonthS=m.liDayS*30
liYearS=m.liMonthS*12

lii=INT(m.ltDT/m.liYearS) && zjisti cel roky
liy=m.ltDT-m.liYearS*m.lii && zjisti zbytek
lcYear=LTRIM(STR(m.lii,11)) && peve roky na etzec
ltDT=m.liy && pepi zbytek

lii=INT(m.ltDT/m.liMonthS) && zjisti cel msce
liy=m.ltDT-m.liMonthS*m.lii && zjisti zbytek
lcMonth=LTRIM(STR(m.lii,11)) && peve msce na etzec
ltDT=m.liy && pepi zbytek

lii=INT(m.ltDT/m.liDayS) && zjisti cel dny
liy=m.ltDT-m.liDayS*m.lii && zjisti zbytek
lcDay=LTRIM(STR(m.lii,11)) && peve dny na etzec
ltDT=m.liy && pepi zbytek

lii=INT(m.ltDT/m.liHourS) && zjisti cel hodiny
liy=m.ltDT-m.liHourS*m.lii && zjisti zbytek
lcHour=LTRIM(STR(m.lii,11)) && peve hodiny na etzec
ltDT=m.liy && pepi zbytek

lii=INT(m.ltDT/m.liMinS) && zjisti cel minuty
liy=m.ltDT-m.liMinS*m.lii && zjisti zbytek
lcMin=LTRIM(STR(m.lii,11)) && peve minuty na etzec
lcSec=LTRIM(STR(m.liy,11)) && peve sekundy na etzec

RETURN IIF(VAL(m.lcYear)>0,m.lcYear+IIF(VAL(m.lcYear)=1," year "," years "),"")+;
       IIF(VAL(m.lcMonth)>0,m.lcMonth+IIF(VAL(m.lcMonth)=1," month "," months "),"")+;
       IIF(VAL(m.lcDay)>0,m.lcDay+IIF(VAL(m.lcDay)=1," day "," days "),"")+;
       IIF(VAL(m.lcHour)>0,m.lcHour+IIF(VAL(m.lcHour)=1," hour "," hours "),"")+;
       IIF(VAL(m.lcMin)>0,m.lcMin+IIF(VAL(m.lcMin)=1," minute "," minutes "),"")+;
       IIF(VAL(m.lcSec)>0,m.lcSec+IIF(VAL(m.lcSec)=1," second "," seconds "),"")

ENDPROC

********************************************
*
*********************************************
PROCEDURE WaitToIE_RS(loIE) && Vykvac funkce pro IE
* loIE - Objekt IE
LOCAL liCount,liMax
liMax=600
liCount=0
DO WHILE m.loIE.ReadyState<=3 AND m.liCount<m.liMax
   =Sleep(250)
   liCount=m.liCount+1
ENDDO
RETURN m.liCount<m.liMax
ENDPROC

********************************************
*
*********************************************
PROCEDURE CopyCursor(lcSource,lcDest,llFill,llCreate) && Kopie kurzoru
* lcSource - Zdrojov alias
* lcDest   - Clov alias
* llFil    - Pznak naplnn clovho aliasu
* llCreate - Pznak vytvoen
LOCAL lii,liy
LOCAL laFields(1)
SELE (m.lcSource)
IF llCreate
   =AFIELDS(laFields)
   FOR lii=1 TO ALEN(laFields,1) && vyma pebyten daje
       FOR liy=7 TO 15  && tyto nadbyten buky vyma
           laFields(m.lii,m.liy)='' 
       NEXT
   NEXT
   SELE 0   && voln alias
   CREATE CURSOR (m.lcDest) FROM ARRAY laFields  && vytvo kurzor dle matice
ENDIF

IF m.llFill
   SELE (m.lcSource)
   DIME laFields(1)
   SCAN ALL
        SCATTER TO laFields MEMO
        INSERT INTO (m.lcDest) FROM ARRAY laFields
   ENDSCAN
ENDIF
RETURN .T.
ENDPROC

****************************************************************
* Oprav zdrojov kd - ukon dky znaky CRLF
****************************************************************
PROCEDURE RepairSource(lcSource)
*@lcSource - Zdrojov kd

LOCAL liCR,liLF
* Zjisti, zda to nemus upravit
liCR=AT(CHR(13),m.lcSource,1)
liLF=AT(CHR(10),m.lcSource,1)
        
* Pokud tam nen pln CRLF, ale CR nebo LF
IF m.liCR=0 OR m.liLF=0
   * Pak to nahra CRLF
   lcSource=STRTRAN(m.lcSource,IIF(m.liCR=0,CHR(10),CHR(13)),CRLF)
ENDIF
ENDPROC


****************************************************************
* Odstran z UTF8 diakritiku pro etinu
****************************************************************
PROCEDURE UTF8Tocs(laCov,lcText) && Odstran z UTF8 diakritiku pro etinu
* laCov  - Konverzn matice
* lcText - Text pro konverzi
LOCAL lii
FOR lii=1 TO ALEN(m.laCov,1)
    lcText=STRTRAN(m.lcText,m.laCov(m.lii,1),m.laCov(m.lii,2))
NEXT
RETURN m.lcText


***********************
* pevod textu z ISO-8859-2 do WIN 1250
***********************
PROCEDURE GetCTISO2WIN(lcCT)
*@lcCT - Sem se vrt kdovac tabulka

**** tvorba kdovac tabulky mezi ISO-8859-2 a WIN 1250
lcCT=""
FOR lii=1 TO 255
    lcCT=lcCT+CHR(lii)
NEXT

lcCT=STUFF(lcCT,0xB5,1,CHR(0xBE))
lcCT=STUFF(lcCT,0xBE,1,CHR(0x9E))
lcCT=STUFF(lcCT,0xAE,1,CHR(0x8E))
lcCT=STUFF(lcCT,0xBB,1,CHR(0x9D))
lcCT=STUFF(lcCT,0xAB,1,CHR(0x8D))
lcCT=STUFF(lcCT,0xB9,1,CHR(0x9A))
lcCT=STUFF(lcCT,0xA9,1,CHR(0x8A))
lcCT=STUFF(lcCT,0xA5,1,CHR(0xBC))
**** konec tvorby kdovac tabulky

*?lcText
*lcText=SYS(15,lcChar,lcText)
*?lctext
ENDPROC


* pevod textu z WIN 1250 do ISO-8859-2
***********************
PROCEDURE GetCTWIN2ISO(lcCT)
*@lcCT - Sem se vrt kdovac tabulka

**** tvorba kdovac tabulky mezi WIN 1250 a ISO-8859-2
LOCAl lcCT
lcCT=""
FOR lii=1 TO 255
    lcCT=lcCT+CHR(lii)
NEXT

lcCT=STUFF(lcCT,0xBE,1,CHR(0xB5))
lcCT=STUFF(lcCT,0x9E,1,CHR(0xBE))
lcCT=STUFF(lcCT,0x8E,1,CHR(0xAE))
lcCT=STUFF(lcCT,0x9D,1,CHR(0xBB))
lcCT=STUFF(lcCT,0x8D,1,CHR(0xAB))
lcCT=STUFF(lcCT,0x9A,1,CHR(0xB9))
lcCT=STUFF(lcCT,0x8A,1,CHR(0xA9))
lcCT=STUFF(lcCT,0xBC,1,CHR(0xA5))
**** konec tvorby kdovac tabulka

*lcText="ab"+CHR(0xBE)+CHR(0x9E)+CHR(0x8E)+CHR(0x9D)+CHR(0x8D)+CHR(0x9A)+CHR(0x8A)+CHR(0xBC)+"cd"
*?lcText
*lcText=SYS(15,lcChar,lcText)
*?lctext
ENDPROC

********************************************
*
*********************************************
PROCEDURE ISO2WIN(lcString,lcCT)
RETURN SYS(15,lcCT,lcString)
ENDPROC

********************************************
*
*********************************************
PROCEDURE WIN2ISO(lcString,lcCT)
RETURN SYS(15,lcCT,lcString)
ENDPROC


********************************************
*
*********************************************
PROCEDURE ToQP(lcText)
LOCAL lcRet,lcChar,lii,liChar,liEnter,liy
lcRet=""
liEnter=0
FOR lii = 1 TO LEN(lcText)
    lcChar = SUBST(lcText,lii, 1)
    liChar=ASC(lcChar)

    IF (liChar>= 33 AND liChar<= 60) OR (liChar>= 62 AND liChar<= 126)
       lcRet=lcRet+lcChar
       liEnter=liEnter+1
    ELSE
       lcRet=lcRet+"=" + RIGHT(TRANSFORM(liChar,"@0"),2)
       liEnter=liEnter+3
    ENDIF

    IF liEnter=60
       liEnter=0
       lcRet=lcRet+CRLF
    ELSE
       IF liEnter>60
          lcRet=STUFF(lcRet,LEN(lcRet)-2,0,CRLF)
          liEnter=3
       ENDIF
    ENDIF
NEXT
RETURN lcRet
ENDPROC


********************************************
*
*********************************************
PROCEDURE C4ToI(lcInt)  && slo v etzcovm tvaru WINAPI 32 bit
RETURN ASC(LEFT(m.lcInt,1))+;
       ASC(SUBS(m.lcInt,2,1))*256+;
       ASC(SUBS(m.lcInt,3,1))*65536+;
       ASC(RIGHT(m.lcInt,1))*256*65536  && vra slo v decimlnm tvaru
ENDPROC


********************************
PROCEDURE C4ToL(lcLong)  && slo v etzcovm tvaru WINAPI 32 bit - signed
LOCAL liVal
liVal=ASC(LEFT(lcLong,1))+;
                  ASC(SUBS(lcLong,2,1))*256+;
                  ASC(SUBS(lcLong,3,1))*65536+;
                  ASC(RIGHT(lcLong,1))*16777216

RETURN IIF(liVal<=0x7FFFFFFF,liVal,liVal-(0xFFFFFFFF+1))
