#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "lamer.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_lamer_service")
RETURN .T.


**************************************************
DEFINE CLASS _lamer_service AS _service
   Name="_lamer_service"

   
   PROCEDURE AfterInit(loJC)
      =loJC.AddCommand(_cmd_LAMER,"LAMER","Return the lamer quote")
      =loJC.AddCommand(_cmd_LAMER_NEW,"LAMER #NEW","Return the new lamer quotes")
      =loJC.AddCommand(_cmd_LAMER_SEARCH,"LAMER #SEARCH","Find lamer quotes")

      =loJC.AddCommand(_cmd_HELP_LAMER,"HELP LAMER","")
      =loJC.AddCommand(_cmd_HELP_LAMER_NEW,"HELP LAMER #NEW","")
      =loJC.AddCommand(_cmd_HELP_LAMER_SEARCH,"HELP LAMER #SEARCH","")
   ENDPROC
   
   PROCEDURE OpenSources(loJC)
      * loJC - Object reference to jabber object
*!*	      IF loJC.OpenTable(m.This.MainPath+"jbrb.dbf",This.ARB,"AGAIN",m.This.DataSessionID)#ErrOK
*!*	         RETURN .F.
*!*	      ENDIF
   ENDPROC

   PROCEDURE CloseSources(loJC)
      * loJC - Object reference to jabber object
*!*	      IF USED(This.ARB)
*!*	         USE IN (This.ARB)
*!*	      ENDIF
   ENDPROC

   PROCEDURE GetMessage(loSP)
      * Test na chybu
      IF m.loSP.oJCP.nError>0
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL loMsg,lii,liXID,lcPom,lcData,lcHTML,llSeek,liMax,liy,liMax2,lcUNick,liXX400I,loThread
      LOCAL ARRAY laPom(1)
      
      IF !m.loSP.ParseCommand()
         RETURN _Serv_Run_Next
      ENDIF

      DO CASE
         CASE m.loSP.iWords>=3 AND m.loSP.aUWords(1)=="LAMER" AND m.loSP.aUWords(2)=="#SEARCH"
              m.loSP.oJC.AddSpy(@loSP,_cmd_LAMER_SEARCH,0,"","")
              loThread=CREATEOBJECT("_thr_lamer_search")
              loThread.oSP=m.loSP
              m.loSP.oJC.tmrThreads.AddThread(loThread)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="LAMER" AND m.loSP.aUWords(2)=="#NEW"
              m.loSP.oJC.AddSpy(@loSP,_cmd_LAMER_NEW,0,"","")

              loThread=CREATEOBJECT("_thr_lamer_new")
              loThread.oSP=m.loSP
              m.loSP.oJC.tmrThreads.AddThread(loThread)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="LAMER" AND LEFT(m.loSP.aUWords(2),1)="#"
              m.loSP.oJC.AddSpy(@loSP,_cmd_LAMER,0,m.loSP.aWords(2),"")

              loThread=CREATEOBJECT("_thr_lamer_id")
              loThread.oSP=m.loSP
              m.loSP.oJC.tmrThreads.AddThread(loThread)
              RETURN _Serv_Run_Processed



         CASE INLIST(m.loSP.iWords,2,3) AND m.loSP.aUWords(1)=="HELP"
              DO CASE
                 CASE m.loSP.iWords=2 AND m.loSP.aUWords(2)=="LAMER"
                      liXX400I=cmd_HELP_LAMER
                      lcData=[Return the lamer quote]+CRLF+;
                             [!LAMER #id]+CRLF+CRLF+;
                             [ id - number of lammer quote]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !lamer #689]

                      lcHTML=[<span style="font-weight: bold;">Return the lamer quote<br />]+;
                             [!LAMER #id</span><br /><br />]+;
                             [ language - number of lammer quote<br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !lamer #689]

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="LAMER" AND m.loSP.aUWords(3)=="#NEW"
                      liXX400I=cmd_HELP_LAMMER_NEW
                      lcData=[Return the new lamer quotes]+CRLF+;
                             [!LAMER #NEW]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !lamer #new]

                      lcHTML=[<span style="font-weight: bold;">Return the new lamer quotes<br />]+;
                             [!LAMER #NEW</span><br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !lamer #new]


                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="LAMER" AND m.loSP.aUWords(3)=="#SEARCH"
                      liXX400I=cmd_HELP_LAMMER_SEARCH
                      lcData=[Find lamer quotes]+CRLF+;
                             [!LAMER #SEARCH]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !lamer #search]

                      lcHTML=[<span style="font-weight: bold;">Find lamer quotes<br />]+;
                             [!LAMER #SEARCH</span><br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !lamer #search]

                 OTHERWISE
                     RETURN _Serv_Run_Free

              ENDCASE


              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel

              loMsg.Body=lcData
              loMsg.HTML=lcHTML
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed

         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC


ENDDEFINE


**************************
DEFINE CLASS _thr_lamer_id AS _Thread
   Name="_thr_lamer_id"
   
   oSP=.NULL.
   _cmdFailed="cmd_Failed"
   thrdID=0

   _ReadIndex=0
   _ReadIndexMax=100
   _ReadData=0

   ADD OBJECT cmd_Start AS _Command
   ADD OBJECT cmd_Read AS _Command
   ADD OBJECT cmd_Return AS _Command
   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   
   PROCEDURE Destroy()
      =bot_thrcancel(This.thrdID)
   ENDPROC


   PROCEDURE cmd_Start.RunCommand()
      This.Parent.thrdID=bot_readurl("http://www.lamer.cz/?item=show&id="+SUBSTR(This.Parent.oSP.aUWords(2),2))
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_Read.RunCommand()
      LOCAL liRet
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      liRet=bot_getthrstate(This.Parent.thrdID)

      IF liRet>=0
         lipt=bot_getthrdata(This.Parent.thrdID)
         lcST=SYS(2600,lipt,12) && Nati strukturu
         This.Parent._ReadData=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      ENDIF

      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndexMax OR liRet<0,_cmd_Failed,;
             IIF(liRet=0,_cmd_Running,_cmd_End))
   ENDPROC

   PROCEDURE cmd_Return.RunCommand()
      LOCAL loMsg,loSP,lcText,loTDs,lii,lcPom,lcPom2,lcST,lipt,lilg
      loSP=This.Parent.oSP

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      lipt=bot_getthrdata(This.Parent.thrdID)
      lcST=SYS(2600,lipt,12) && Nati strukturu
      lipt=C4ToI(LEFT(lcST,4)) && ukazatel na etzc
      lilg=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      lcPom=SYS(2600,lipt,lilg)

      lcPom=STREXTRACT(lcpom,'<td class="quote"',"</td>")
      lcPom=SUBSTR(lcPom,AT(">",lcPom)+1)

      IF LEN(lcPom)>0
         lcPom=ISO2WIN(SUBSTR(lcPom,ATC("<br>",lcPom,1)+4),m.loSP.oJC.CTFromISO)

         loMsg.Body=STRCONV("Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+CRLF+HTMLStringTranStr(STRTRAN(STRTRAN(STRTRAN(lcPom,"<br>",CRLF),"<i>",""),"</i>","")),9)


         lcPom=STRTRAN(lcPom,"<br>","<br />")
         lii=RAT("<i>",lcPom)
         IF lii=0
            lcPom2=""
         ELSE
            lcPom2=SUBSTR(lcPom,lii)
            lcPom=LEFT(lcPom,lii-1)
         ENDIF

         lcPom=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+lcPom+[</span>]
         lcPom2=IIF(LEN(lcPom2)=0,"",STRTRAN(STRTRAN(lcPom2,"<i>","<span style='font-family: Tahoma; font-style: italic;'>"),"</i>","</span>"))

         loMsg.HTML=STRCONV("<span style='font-family: Tahoma; font-weight: bold; font-style: normal;'>Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+[</span><br />]+lcPom+lcPom2,9)
      ELSE
         loMsg.Body=STRCONV("Lamer panic... Quote is not found",9)
      ENDIF

      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb

      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      DO CASE 

         CASE LOWER(loCommand.Name)="cmd_read"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text - timeout",9)

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      =bot_freethrdata(This.Parent.thrdID)
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE




DEFINE CLASS _thr_lamer_new AS _Thread
   Name="_thr_lamer_new"
   
   oSP=.NULL.
   thrdID=0
   _cmdFailed="cmd_Failed"

   _ReadIndex=0
   _ReadIndexMax=100
   _ReadData=0

   ADD OBJECT cmd_Start AS _Command
   ADD OBJECT cmd_Read AS _Command
   ADD OBJECT cmd_Return AS _Command
   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   

   PROCEDURE Destroy()
      =bot_thrcancel(This.thrdID)
   ENDPROC

   PROCEDURE cmd_Start.RunCommand()
      This.Parent.thrdID=bot_readurl("http://www.lamer.cz/rss.pl")
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Read.RunCommand()
      LOCAL liRet
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      liRet=bot_getthrstate(This.Parent.thrdID)

      IF liRet>=0
         lipt=bot_getthrdata(This.Parent.thrdID)
         lcST=SYS(2600,lipt,12) && Nati strukturu
         This.Parent._ReadData=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      ENDIF

      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndexMax OR liRet<0,_cmd_Failed,;
             IIF(liRet=0,_cmd_Running,_cmd_End))
   ENDPROC

   PROCEDURE cmd_Return.RunCommand()
      LOCAL loMsg,loSP,lcText,loTDs,lii,lcPom,liCount,lcPom2,lcBody,lcHTML,lcTitle,;
            lcPom3,liy,lcLink,lcText,lcDate,lcData
      loSP=This.Parent.oSP

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      lipt=bot_getthrdata(This.Parent.thrdID)
      lcST=SYS(2600,lipt,12) && Nati strukturu
      lipt=C4ToI(LEFT(lcST,4)) && ukazatel na etzc
      lilg=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      lcData=SYS(2600,lipt,lilg)

      liCount=OCCURS("<item>",lcData)

      STORE "" TO lcBody,lcHTML,lcExtra

*susp
      FOR lii=1 TO liCount
          * nati item
          lcPom=STREXTRACT(lcData,'<item>',"</item>",lii)

          * nati title
          lcPom2=STREXTRACT(lcPom,'<title>',"</title>")
          lcTitle=STREXTRACT(lcPom2,'<![CDATA[',']]>')

          * nati odkaz
          lcLink=STREXTRACT(lcPom,'<link>',"</link>")

          * nati tlo
          lcText=STREXTRACT(lcPom,'<description>',"</description>")
          lcText=ISO2WIN(STREXTRACT(lcText,'<![CDATA[',']]>'),m.loSP.oJC.CTFromISO)

          * nati datum
          lcDate=STREXTRACT(lcPom,'<pubDate>',"</pubDate>")


          lcBody=lcBody+HTMLStringTranStr(lcTitle)+[(]+lcDate+[)]+CRLF
          lcHTML=lcHTML+[<span style='font-family: Tahoma; font-weight: bold; font-style: normal;'>]+lcTitle+[</span> (]+lcDate+[)<br />]

          lcExtra=lcExtra+;
                  [<x xmlns='jabber:x:oob'><url>]+lcLink+[</url><desc>]+lcTitle+[</desc></x>]


          lcBody=lcBody+STRTRAN(HTMLStringTranStr(lcText),"<br/>",CRLF)+CRLF+CRLF

          liy=RAT("<br/><br/>",lcText)
          IF liy=0
             lcPom3=[]
             lcPom2=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+lcText+[</span>]
          ELSE
             lcPom3=[<br /><span style='font-family: Tahoma; font-style: italic;'>]+SUBSTR(lcText,liy+10)+[</span>]
             lcPom2=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+LEFT(lcText,liy-1)+[</span>]
          ENDIF

          lcHTML=lcHTML+lcPom2+lcPom3+[<br /><br />]
      NEXT

      IF LEN(lcBody)>0
         loMsg.Body=STRCONV(lcBody,9)
         loMsg.HTML=STRCONV(lcHTML,9)
         loMsg.Extra=lcExtra
      ENDIF

      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)

      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb
      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      DO CASE 
         CASE LOWER(loCommand.Name)="cmd_read"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text - timeout",9)


         CASE LOWER(loCommand.Name)="cmd_return"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text",9)

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE



DEFINE CLASS _thr_lamer_search AS _Thread
   Name="_thr_lamer_search"
   
   oSP=.NULL.
   thrdID=0
   _cmdFailed="cmd_Failed"
   NextURL=""

   StateEx=0
   _ReadIndex=0
   _ReadIndexMax=300
   _ReadData=0

   ADD OBJECT cmd_Start AS _Command
   ADD OBJECT cmd_Read AS _Command
   ADD OBJECT cmd_Return AS _Command
   ADD OBJECT cmd_StartNext AS _Command
   ADD OBJECT cmd_ReadNext AS _Command
   ADD OBJECT cmd_ReturnNext AS _Command

   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   
   PROCEDURE Destroy()
      =bot_thrcancel(This.thrdID)
   ENDPROC


   PROCEDURE Analyse(lcHTML,laOut)
      LOCAL lcPom,liCount,lii,lcQuote,lcPom,lcpom2,liy

      STORE "" TO laOut
      liCount=OCCURS('<td class="quote"',lcHTML)


      lcWords=""
      FOR lii=3 TO This.oSP.iWords
          lcWords=lcWords+This.oSP.aWords(lii)+"+"
      NEXT
      lcWords=LEFT(lcWords,LEN(lcWords)-1)

      laOut(1)=STRCONV("Lamer Search - ",9)+lcWords+CRLF+CRLF

      laOut(2)=STRCONV("Lamer Search - ",9)+lcWords+"<br /><br />"

      FOR lii=2 TO liCount-1
          lcPom=STREXTRACT(lcHTML,'<td class="quote"',"</td>",lii)
          lcPom=SUBSTR(lcPom,AT(">",lcPom)+1)

          lcPom2=STREXTRACT(lcPom,'<a',"</a>")
          lcQuote=SUBSTR(lcPom2,AT(">",lcPom2)+1)
      
          lcPom=ISO2WIN(SUBSTR(lcPom,ATC("<br>",lcPom,1)+4),This.oSP.oJC.CTFromISO)

          laOut(1)=laOut(1)+;
                   STRCONV("Lamer "+lcQuote+CRLF+HTMLStringTranStr(STRTRAN(STRTRAN(STRTRAN(lcPom,"<br>",CRLF),"<i>",""),"</i>","")),9)

          lcPom=STRTRAN(lcPom,"<br>","<br />")

          liy=RAT("<i>",lcPom)
          IF liy=0
             lcPom2=""
          ELSE
             lcPom2=SUBSTR(lcPom,liy)
             lcPom=LEFT(lcPom,liy-1)
          ENDIF

          lcPom=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+lcPom+[</span>]
          lcPom2=IIF(LEN(lcPom2)=0,"",STRTRAN(STRTRAN(lcPom2,"<i>","<span style='font-family: Tahoma; font-style: italic;'>"),"</i>","</span>"))

          laOut(2)=laOut(2)+;
                   STRCONV("<span style='font-family: Tahoma; font-weight: bold; font-style: normal;'>Lamer "+lcQuote+[</span><br />]+lcPom+lcPom2,9)

          laOut(3)=laOut(3)+;
                   [<x xmlns='jabber:x:oob'><url>]+StrTranHTMLString([http://www.lamer.cz/?item=show&id=]+SUBST(lcQuote,2))+[</url><desc>Quote ]+lcQuote+[</desc></x>]

      NEXT

      * Nati posledn class="quote" a nati z nj odkaz na dal strnku
      lcPom=STREXTRACT(lcHTML,'<td class="quote"',"</td>",liCount)
      lii=OCCURS('<a ',lcPom)
      * Nati odkaz
      lcPom2=STREXTRACT(lcPom,'<a ',">",lii)
      lcPom2=STREXTRACT(lcPom2,'href="','"')

      * Nati text odkazu
      lcPom=STREXTRACT(lcPom,'<a ',"</a>",lii)
      lcPom=SUBSTR(lcPom,AT(">",lcPom)+1)

*<a class="plus" href="?item=browse&amp;action=search&amp;search=pic&amp;page=2">&gt;</a>

      IF !EMPTY(lcPom2) AND lcPom=="&gt;" 
         This.NextURL="http://www.lamer.cz/"+HTMLStringTranStr(lcPom2)
         DEBUGOUT "Lamer - ReRun: "+This.NextURL
      ELSE
         This.NextURL=""
      ENDIF
   ENDPROC

   PROCEDURE cmd_Start.RunCommand()
*This.Parent.oSP.aWords(2)
*Content-Type: text/plain; charset="utf-8"

      LOCAL lcHeader,lcParam,lcObject,lcServer,lii,lcWords
      lcWords=""
      FOR lii=3 TO This.Parent.oSP.iWords
          lcWords=lcWords+This.Parent.oSP.aWords(lii)+"+"
      NEXT
      lcWords=LEFT(lcWords,LEN(lcWords)-1)

      lcHeader=[Content-Type: application/x-www-form-urlencoded; charset="utf-8"]+CHR(13)+CHR(10)
      lcParam="item=browse&action=search&search="+;
              lcWords+;
              "&submitted="+STRCONV("Najt",9)
      lcObject="?item=search"
      lcServer="www.lamer.cz"

      This.Parent.thrdID=bot_readurlbypost(lcServer,lcObject,lcParam,lcHeader,256)
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Read.RunCommand()
      LOCAL liRet
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      liRet=bot_getthrstate(This.Parent.thrdID)

      IF liRet>=0
         lipt=bot_getthrdata(This.Parent.thrdID)
         lcST=SYS(2600,lipt,12) && Nati strukturu
         This.Parent._ReadData=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      ENDIF

      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndexMax OR liRet<0,_cmd_Failed,;
             IIF(liRet=0,_cmd_Running,_cmd_End))
   ENDPROC

   PROCEDURE cmd_Return.RunCommand()
      LOCAL loMsg,loSP,lcPom,lcST,lipt,lilg
      LOCAL ARRAY laOut(3)
      loSP=This.Parent.oSP

      lipt=bot_getthrdata(This.Parent.thrdID)
      lcST=SYS(2600,lipt,12) && Nati strukturu
      lipt=C4ToI(LEFT(lcST,4)) && ukazatel na etzc
      lilg=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      lcPom=SYS(2600,lipt,lilg)

      This.Parent.Analyse(lcPom,@laOut)

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      IF LEN(laOut(1))>0
         loMsg.Body=laOut(1)
         loMsg.HTML=laOut(2)
         loMsg.Extra=laOut(3)
      ELSE
         loMsg.Body=STRCONV("Quotes not found.",9)
      ENDIF

      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)

      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_StartNext.RunCommand()
      IF EMPTY(This.Parent.NextURL)
         RETURN _cmd_End
      ENDIF

      This.Parent.thrdID=bot_readurl(This.Parent.NextURL,256)
      This.Parent._ReadIndex=0
      This.Parent._ReadData=0
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_ReadNext.RunCommand()
      IF EMPTY(This.Parent.NextURL)
         RETURN _cmd_End
      ENDIF

      LOCAL liRet
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      liRet=bot_getthrstate(This.Parent.thrdID)
      This.Parent.StateEx=bot_getthrstateex(This.Parent.thrdID)

      IF liRet>=0
         lipt=bot_getthrdata(This.Parent.thrdID)
         lcST=SYS(2600,lipt,12) && Nati strukturu
         This.Parent._ReadData=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      ENDIF

      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndexMax OR liRet<0,_cmd_Failed,;
             IIF(liRet=0,_cmd_Running,_cmd_End))
   ENDPROC


   PROCEDURE cmd_ReturnNext.RunCommand()
      LOCAL loMsg,loSP,lcPom,lcST,lipt,lilg
      LOCAL ARRAY laOut(3)
      loSP=This.Parent.oSP

      IF EMPTY(This.Parent.NextURL)
         RETURN _cmd_End
      ENDIF

      lipt=bot_getthrdata(This.Parent.thrdID)
      lcST=SYS(2600,lipt,12) && Nati strukturu
      lipt=C4ToI(LEFT(lcST,4)) && ukazatel na etzc
      lilg=C4ToI(SUBST(lcST,9,4)) && Dlka etzce
      lcPom=SYS(2600,lipt,lilg)

      This.Parent.Analyse(lcPom,@laOut)

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      IF LEN(laOut(1))>0
         loMsg.Body=STRCONV(laOut(1),9)
         loMsg.HTML=STRCONV(laOut(2),9)
         loMsg.Extra=laOut(3)
      ELSE
         loMsg.Body=STRCONV("Quotes not found.",9)
      ENDIF

      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)

      IF EMPTY(This.Parent.NextURL)
         This.Parent.ReRun=0
         RETURN _cmd_End
      ELSE
         This.Parent.ReRun=This.Parent.GetCommandIndex("cmd_StartNext")
         RETURN _cmd_ReRun
      ENDIF
   ENDPROC



   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb
      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce
      loMsg.From=m.loSP.ReplyFrom && Odeslatel

      DO CASE 
         CASE INLIST(LOWER(loCommand.Name),"cmd_read","cmd_readnext")
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text - timeout",9)

         CASE INLIST(LOWER(loCommand.Name),"cmd_return","cmd_returnnext")
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text",9)

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      =bot_freethrdata(This.Parent.thrdID)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE
