#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "lamer.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_lamer_service")
RETURN .T.


**************************************************
DEFINE CLASS _lamer_service AS _service
   Name="_lamer_service"

   
   PROCEDURE AfterInit(loJC)
      =loJC.AddCommand(_cmd_LAMER,"LAMER","Return the lamer quote")
      =loJC.AddCommand(_cmd_LAMER_NEW,"LAMER NEW","Return the new lamer quotes")

      =loJC.AddCommand(_cmd_HELP_LAMER,"HELP LAMER","")
      =loJC.AddCommand(_cmd_HELP_LAMER_NEW,"HELP LAMER NEW","")
   ENDPROC
   
   PROCEDURE OpenSources(loJC)
      * loJC - Object reference to jabber object
*!*          IF loJC.OpenTable(m.This.MainPath+"jbrb.dbf",This.ARB,"AGAIN",m.This.DataSessionID)#ErrOK
*!*             RETURN .F.
*!*          ENDIF
   ENDPROC

   PROCEDURE CloseSources(loJC)
      * loJC - Object reference to jabber object
*!*          IF USED(This.ARB)
*!*             USE IN (This.ARB)
*!*          ENDIF
   ENDPROC

   PROCEDURE GetMessage(loSP)
      * Test na chybu
      IF m.loSP.oJCP.nError>0
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL loMsg,lii,liXID,lcPom,lcData,lcHTML,llSeek,liMax,liy,liMax2,lcUNick,liXX400I,loThread
      LOCAL ARRAY laPom(1)
      
      IF !m.loSP.ParseCommand()
         RETURN _Serv_Run_Next
      ENDIF

      DO CASE
         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="LAMER" AND LEFT(m.loSP.aUWords(2),1)="#"
              m.loSP.oJC.AddSpy(@loSP,_cmd_LAMER,0,m.loSP.aWords(2),"")

              loThread=CREATEOBJECT("_thr_lamer_id")
              loThread.oSP=m.loSP
              m.loSP.oJC.tmrThreads.AddThread(loThread)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="LAMER" AND m.loSP.aUWords(2)="NEW"
              m.loSP.oJC.AddSpy(@loSP,_cmd_LAMER_NEW,0,"","")

              loThread=CREATEOBJECT("_thr_lamer_new")
              loThread.oSP=m.loSP
              m.loSP.oJC.tmrThreads.AddThread(loThread)
              RETURN _Serv_Run_Processed


         CASE INLIST(m.loSP.iWords,2,3) AND m.loSP.aUWords(1)=="HELP"
              DO CASE
                 CASE m.loSP.iWords=2 AND m.loSP.aUWords(2)=="LAMER"
                      liXX400I=cmd_HELP_LAMER
                      lcData=[Return the lamer quote]+CRLF+;
                             [!LAMER #id]+CRLF+CRLF+;
                             [ id - number of lammer quote]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !lamer #689]

                      lcHTML=[<span style="font-weight: bold;">Return the lamer quote<br />]+;
                             [!LAMER #id</span><br /><br />]+;
                             [ language - number of lammer quote<br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !lamer #689]

                 CASE m.loSP.iWords=3 AND m.loSP.aUWords(2)=="LAMER" AND m.loSP.aUWords(3)=="NEW"
                      liXX400I=cmd_HELP_LAMMER_NEW
                      lcData=[Return the new lamer quotes]+CRLF+;
                             [!LAMER NEW]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !lamer new]

                      lcHTML=[<span style="font-weight: bold;">Return the new lamer quotes<br />]+;
                             [!LAMER NEW</span><br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !lamer new]

                 OTHERWISE
                     RETURN _Serv_Run_Free

              ENDCASE


              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.Body=lcData
              loMsg.HTML=lcHTML
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed

         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC


ENDDEFINE


**************************
DEFINE CLASS _thr_lamer_id AS _Thread
   Name="_thr_lamer_id"
   
   oSP=.NULL.
   oIE=.NULL.
   _cmdFailed="cmd_Failed"

   _ReadIndex=0
   _ReadIndeMax=100

   ADD OBJECT cmd_Start AS _Command
   ADD OBJECT cmd_OpenURL AS _Command
   ADD OBJECT cmd_Read AS _Command
   ADD OBJECT cmd_Return AS _Command
   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   
   hISession=0
   hURL=0
   cData=""

   PROCEDURE cmd_Start.RunCommand()
      This.Parent.oIE=CREATEOBJECT("internetexplorer.application")
      This.Parent.oIE.Navigate2("http://www.lamer.cz/?item=show&id="+SUBSTR(This.Parent.oSP.aUWords(2),2))
*DEBUGOUT SYS(16)+ " "+"http://www.lamer.cz/?item=show&id="+SUBSTR(This.Parent.oSP.aUWords(2),2)

*!*    DEBUGOUT SYS(16)
*!*          LOCAL lcAgent,lcPom
*!*          DECLARE INTEGER InternetOpen IN wininet.DLL STRING @sAgent, ;
*!*                  INTEGER lAccessType, STRING @sProxyName, ;
*!*                  STRING @sProxyBypass, INTEGER lFlags

*!*          lcAgent = "Lamer Service for FoxBot"+CHR(0)
*!*          lcPom=CHR(0)
*!*          This.Parent.hISession = InternetOpen(@lcPom, INTERNET_OPEN_TYPE_PRECONFIG,@lcPom, @lcPom, SYNCHRONOUS)

*!*          IF This.Parent.hISession = 0
*!*             RETURN _cmd_Failed
*!*          ENDIF
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_OpenURL.RunCommand()

*DEBUGOUT SYS(16)
*!*          LOCAL lcURL,lcPom

*!*          DECLARE INTEGER InternetOpenUrl IN wininet.DLL ;
*!*                  INTEGER hInternetSession, STRING @sUrl, STRING @sHeaders, ;
*!*                  INTEGER lHeadersLength, INTEGER lFlags, INTEGER lContext


*!*          lcURL = "http://www.lamer.cz/?item=show&id="+SUBSTR(This.Parent.oSP.aUWords(2),2)+CHR(0)
*!*          lcPom=CHR(0)
*!*          This.Parent.hURL = InternetOpenUrl(This.Parent.hISession, @lcURL, @lcPom,0, INTERNET_FLAG_RELOAD, 0)

*!*          IF This.Parent.hURL = 0
*!*             RETURN _cmd_Failed
*!*          ENDIF
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Read.RunCommand()
*DEBUGOUT SYS(16)
*!*          LOCAL lcBuffer,lBytesRead,liRead
*!*          DECLARE INTEGER InternetReadFile IN wininet.DLL INTEGER hfile, ;
*!*                  STRING @sBuffer, INTEGER lNumberofBytesToRead, INTEGER @lBytesRead

*!*          lcBuffer = SPACE(32767)
*!*          lBytesRead = 0
*!*          liRead = InternetReadFile(This.Parent.hURL, @lcBuffer,LEN(lcBuffer), @lBytesRead)
*!*          This.Parent.cData=This.Parent.cData+IIF(lBytesRead>0,lcBuffer,"")
*!*          RETURN IIF(liRead=0,_cmd_Failed,IIF(lBytesRead>0,_cmd_Running,_cmd_End))
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndeMax,_cmd_Failed,;
             IIF(This.Parent.oIE.ReadyState<=3,_cmd_Running,_cmd_End))

      RETURN IIF(This.Parent.oIE.ReadyState<=3,_cmd_Running,_cmd_End)
   ENDPROC

   PROCEDURE cmd_Return.RunCommand()
      LOCAL loMsg,loSP,lcText,loTDs,lii,lcPom,lcPom2
      loSP=This.Parent.oSP
*DEBUGOUT SYS(16)

*!*          loTDs=This.Parent.oIE.document.GetElementsByTagName("td")
*!*          FOR lii=0 TO loTDs.Length-1
*!*              IF loTDs.Item(lii).className="quote"
*!*                 EXIT
*!*              ENDIF
*!*          NEXT

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce



*      lcPom=STREXTRACT(This.Parent.cData,'<td class="quote"',"</td>")
      lcPom=STREXTRACT(This.Parent.oIE.document.body.InnerHTML,'<TD class=quote>',"</TD>")

*DEBUGOUT lcpom
      IF LEN(lcPom)>0
         lcPom=ISO2WIN(SUBSTR(lcPom,ATC("<br>",lcPom,1)+4),m.loSP.oJC.CTFromISO)

         loMsg.Body=STRCONV("Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+CRLF+HTMLStringTranStr(STRTRAN(STRTRAN(STRTRAN(lcPom,"<BR>",CRLF),"<I>",""),"</I>","")),9)


         lcPom=STRTRAN(lcPom,"<BR>","<br />")
         lii=RAT("<I>",lcPom)
         IF lii=0
            lcPom2=""
         ELSE
            lcPom2=SUBSTR(lcPom,lii)
            lcPom=LEFT(lcPom,lii-1)
         ENDIF

         lcPom=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+lcPom+[</span>]
         lcPom2=IIF(LEN(lcPom2)=0,"",STRTRAN(STRTRAN(lcPom2,"<I>","<span style='font-family: Tahoma; font-style: italic;'>"),"</I>","</span>"))

         loMsg.HTML=STRCONV("<span style='font-family: Tahoma; font-weight: bold; font-style: normal;'>Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+[</span><br />]+lcPom+lcPom2,9)


*         loMsg.Body=STRCONV("Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+CRLF+CRLF+HTMLStringTranStr(STRTRAN(lcPom,"<br>",CRLF)),9)
*         loMsg.HTML=STRCONV("Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+CRLF+CRLF+[<span style='font-family: Courier New;'>]+lcPom+[</span>],9)
      ELSE
         loMsg.Body=STRCONV("lamer panic...",9)
      ENDIF

*!*          loMsg.Body=STRCONV(IIF(lii>=loTDs.Length,"lamer panic...",;
*!*                     "Lamer #"+SUBSTR(This.Parent.oSP.aUWords(2),2)+CRLF+CRLF+loTDs.Item(lii).innerText),9)


      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      This.Parent.oIE=.NULL.


*!*          DECLARE short InternetCloseHandle IN wininet.DLL INTEGER hInst
*!*          =InternetCloseHandle(This.Parent.hURL)
*!*          =InternetCloseHandle(This.Parent.hISession)
      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb
*!*          DECLARE short InternetCloseHandle IN wininet.DLL INTEGER hInst
*!*    *DEBUGOUT SYS(16)

*!*          IF This.Parent.hURL > 0
*!*             =InternetCloseHandle(This.Parent.hURL)
*!*          ENDIF

*!*          IF This.Parent.hISession > 0
*!*             =InternetCloseHandle(This.Parent.hISession)
*!*          ENDIF

      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce

      DO CASE 
*!*             CASE LOWER(loCommand.Name)="cmd_start"
*!*                  loMsg.Body=STRCONV("lamer panic... I cann't connect",9)

*!*             CASE LOWER(loCommand.Name)="cmd_openurl"
*!*                  loMsg.Body=STRCONV("lamer panic... I cann't open url http://www.lamer.cz",9)

         CASE LOWER(loCommand.Name)="cmd_read"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text - timeout",9)

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE




DEFINE CLASS _thr_lamer_new AS _Thread
   Name="_thr_lamer_new"
   
   oSP=.NULL.
   oIE=.NULL.
   _cmdFailed="cmd_Failed"

   _ReadIndex=0
   _ReadIndeMax=100

   ADD OBJECT cmd_Start AS _Command
   ADD OBJECT cmd_OpenURL AS _Command
   ADD OBJECT cmd_Read AS _Command
   ADD OBJECT cmd_Return AS _Command
   ADD OBJECT cmd_Failed AS _Command WITH iFailed=1
   
   hISession=0
   hURL=0
   cData=""

   PROCEDURE cmd_Start.RunCommand()
      This.Parent.oIE=CREATEOBJECT("internetexplorer.application")
      This.Parent.oIE.Navigate2("http://www.lamer.cz/rss.pl")
*      This.Parent.oIE.Navigate2("file://X:/Jabber/services/lamer/rss.xml")
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_OpenURL.RunCommand()
      RETURN _cmd_End
   ENDPROC

   PROCEDURE cmd_Read.RunCommand()
      This.Parent._ReadIndex=This.Parent._ReadIndex+1
      RETURN IIF(This.Parent._ReadIndex>=This.Parent._ReadIndeMax,_cmd_Failed,;
             IIF(This.Parent.oIE.ReadyState<=3,_cmd_Running,_cmd_End))
   ENDPROC

   PROCEDURE cmd_Return.RunCommand()
      LOCAL loMsg,loSP,lcText,loTDs,lii,lcPom,liCount,lcPom2,lcBody,lcHTML,lcTitle,;
            lcPom3,liy,lcLink,lcText,lcDate
      IF TYPE("This.Parent.oIE.document.xmldocument.xml")#"C"
         RETURN _cmd_Failed
      ENDIF

      loSP=This.Parent.oSP

      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce

      liCount=OCCURS("<item>",This.Parent.oIE.document.xmldocument.xml)
      STORE "" TO lcBody,lcHTML,lcExtra

*susp
      FOR lii=1 TO liCount
          * nati item
          lcPom=STREXTRACT(This.Parent.oIE.document.xmldocument.xml,'<item>',"</item>",lii)

          * nati title
          lcPom2=STREXTRACT(lcPom,'<title>',"</title>")
          lcTitle=STREXTRACT(lcPom2,'<![CDATA[',']]>')

          * nati odkaz
          lcLink=STREXTRACT(lcPom,'<link>',"</link>")

          * nati tlo
          lcText=STREXTRACT(lcPom,'<description>',"</description>")
          lcText=ISO2WIN(STREXTRACT(lcText,'<![CDATA[',']]>'),m.loSP.oJC.CTFromISO)

          * nati datum
          lcDate=STREXTRACT(lcPom,'<pubDate>',"</pubDate>")


          lcBody=lcBody+HTMLStringTranStr(lcTitle)+[(]+lcDate+[)]+CRLF
          lcHTML=lcHTML+[<span style='font-family: Tahoma; font-weight: bold; font-style: normal;'>]+lcTitle+[</span> (]+lcDate+[)<br />]

          lcExtra=lcExtra+;
                  [<x xmlns='jabber:x:oob'><url>]+lcLink+[</url><desc>]+lcTitle+[</desc></x>]


          lcBody=lcBody+STRTRAN(HTMLStringTranStr(lcText),"<br/>",CRLF)+CRLF+CRLF

          liy=RAT("<br/><br/>",lcText)
          IF liy=0
             lcPom3=[]
             lcPom2=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+lcText+[</span>]
          ELSE
             lcPom3=[<br /><span style='font-family: Tahoma; font-style: italic;'>]+SUBSTR(lcText,liy+10)+[</span>]
             lcPom2=[<span style='font-family: Courier New; font-weight: normal; font-style: normal;'>]+LEFT(lcText,liy-1)+[</span>]
          ENDIF

          lcHTML=lcHTML+lcPom2+lcPom3+[<br /><br />]
      NEXT

      IF LEN(lcPom)>0
         loMsg.Body=STRCONV(lcBody,9)
         loMsg.HTML=STRCONV(lcHTML,9)
         loMsg.Extra=lcExtra
      ENDIF

      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
      This.Parent.oIE=.NULL.

      RETURN _cmd_End
   ENDPROC


   PROCEDURE cmd_Failed.RunCommand(loCommand)
      * loCommand - Pkaz ve kterm dolo k chyb
*!*          DECLARE short InternetCloseHandle IN wininet.DLL INTEGER hInst
*!*    *DEBUGOUT SYS(16)

*!*          IF This.Parent.hURL > 0
*!*             =InternetCloseHandle(This.Parent.hURL)
*!*          ENDIF

*!*          IF This.Parent.hISession > 0
*!*             =InternetCloseHandle(This.Parent.hISession)
*!*          ENDIF

      LOCAL loMsg,loSP
      loSP=This.Parent.oSP
      loMsg=CREATEOBJECT("_jbmessage")
      loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
      loMsg.To=m.loSP.ReplyTo && Pjemce

      DO CASE 
*!*             CASE LOWER(loCommand.Name)="cmd_start"
*!*                  loMsg.Body=STRCONV("lamer panic... I cann't connect",9)

*!*             CASE LOWER(loCommand.Name)="cmd_openurl"
*!*                  loMsg.Body=STRCONV("lamer panic... I cann't open url http://www.lamer.cz",9)

         CASE LOWER(loCommand.Name)="cmd_read"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text - timeout",9)


         CASE LOWER(loCommand.Name)="cmd_return" AND TYPE("This.Parent.oIE.document.xmldocument.xml")#"C"
              loMsg.Body=STRCONV("lamer panic... I cann't read lamer text",9)

         OTHERWISE
              loMsg.Body=STRCONV("lamer panic... error panic;",9)

      ENDCASE
      m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)

      RETURN _cmd_End
   ENDPROC

ENDDEFINE
