* READURL.PRG - return the HTML for a specified URL in HURL.MEMO
*
* passed: URLName, in the form "http://www.microsoft.com"
*
* returns: length of HTML file
*
* usage:
*
*      m.urllength = readurl("http://www.microsoft.com")
*
*
* notes:
* 1 - IE does not need to be running to use this, but must be installed,
* as the program uses an option that gets information from the registry
*
* 2 - the URL name apparently MUST be passed in the form shown above.
*


*PARAMETERS UrlName


UrlName="http://www.lamer.cz/?item=show&id=100"

DECLARE INTEGER InternetOpen IN wininet.DLL STRING sAgent, ;
        INTEGER lAccessType, STRING sProxyName, ;
        STRING sProxyBypass, INTEGER lFlags

DECLARE INTEGER InternetOpenUrl IN wininet.DLL ;
        INTEGER hInternetSession, STRING sUrl, STRING sHeaders, ;
        INTEGER lHeadersLength, INTEGER lFlags, INTEGER lContext

DECLARE INTEGER InternetReadFile IN wininet.DLL INTEGER hfile, ;
        STRING @sBuffer, INTEGER lNumberofBytesToRead, INTEGER @lBytesRead

DECLARE short InternetCloseHandle IN wininet.DLL INTEGER hInst

#DEFINE INTERNET_OPEN_TYPE_PRECONFIG 0
#DEFINE INTERNET_OPEN_TYPE_DIRECT 1
#DEFINE INTERNET_OPEN_TYPE_PROXY 3
#DEFINE SYNCHRONOUS 0
#DEFINE INTERNET_FLAG_RELOAD 2147483648
#DEFINE CR CHR(13)

* what application is using Internet services?
sAgent = "VPF 5.0"
lcmemo=""
hInternetSession = InternetOpen(sAgent, INTERNET_OPEN_TYPE_PRECONFIG,'', '', SYNCHRONOUS)

* debugging line - uncomment to see session handle
* WAIT WINDOW "Internet session handle: " + LTRIM(STR(hInternetSession))

IF hInternetSession = 0
   WAIT WINDOW "Internet session cannot be established" TIME 2
   RETURN 0
ENDIF

hUrlFile = InternetOpenUrl(hInternetSession, UrlName, '',0, INTERNET_FLAG_RELOAD, 0)

* debugging line - uncomment to see URL handle
* WAIT WINDOW "URL Handle: " + LTRIM(STR(hUrlFile))

IF hUrlFile = 0
   WAIT WINDOW "URL cannot be opened"
   RETURN 0
ENDIF

susp
DO WHILE .T.
   * set aside a big buffer
   sReadBuffer = SPACE(32767)
   lBytesRead = 0
   m.OK = InternetReadFile(hUrlFile, @sReadBuffer,LEN(sReadBuffer), @lBytesRead)

   * debugging code - uncomment if necessary
   *WAIT WINDOW "hURLFile: " + LTRIM(STR(hURLFile)) + CR + ;
   *                  "lBytesRead: " + LTRIM(STR(lBytesRead)) + CR ;
   *                  + "m.OK      : " + LTRIM(STR(m.OK))

   lcMemo=lcMemo+sReadBuffer

   * uncomment to watch the changes to the memo file
   * MODIFY MEMO hurl.memo

   * error trap - either a read failure or read past eof()
   IF m.OK = 0 OR lBytesRead = 0
      EXIT
   ENDIF
ENDDO

* close all the handles we opened
=InternetCloseHandle(hUrlFile)
=InternetCloseHandle(hInternetSession)

?lcmemo

?


loIE=CREATEOBJECT("internetexplorer.application")
loIE.Navigate2("http://www.lamer.cz/?item=show&id=100")


DO WHILE loIE.ReadyState<=3
ENDDO


?loIE.document.body.innertext
?

******* testovac st
LOCAL liMax,liT0,liT1,liT2
liMax=10000

liT1=SECONDS()
FOR lii=1 TO liMax
NEXT
liT2=SECONDS()
liT0=liT2-liT1

liT1=SECONDS()
FOR lii=1 TO liMax
    loTDs=loIE.document.GetElementsByTagName("td")
    FOR liy=0 TO loTDs.Length-1
        IF loTDs.Item(liy).className="quote"
           EXIT
        ENDIF
    NEXT

    IF liy>=loTDs.Length
       =loTDs.Item(liy).InnerTExt
    ENDIF
NEXT
liT2=SECONDS()
?"IE",liT2-liT1-liT0



liT1=SECONDS()
FOR lii=1 TO liMax
    lcPom=STREXTRACT(lcMemo,'<td class="quote"',"</td>")
    =SUBSTR(lcPom,AT("</a>",lcPom,2)+4)
NEXT
liT2=SECONDS()
?"Parser",liT2-liT1-liT0
