#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "system.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_system_service")
RETURN .T.


**************************************************
DEFINE CLASS _system_service AS _service
   Name="_system_service"


   PROCEDURE AfterInit(loJC)
      DECLARE INTEGER sndPlaySoundA IN winmm.dll STRING lpszSoundName, LONG uFlags

      =loJC.AddCommand(_cmd_CUI,"CUI","Close GUI")
      =loJC.AddCommand(_cmd_LUI,"LUI","Load GUI")
      =loJC.AddCommand(_cmd_RESTART,"RESTART","Restart bot")
      =loJC.AddCommand(_cmd_UNLOAD,"UNLOAD","Unload bot")
      =loJC.AddCommand(_cmd_SUSP,"SUSP","Pause")
      =loJC.AddCommand(_cmd_XING,"?ING","Ping replier")
      =loJC.AddCommand(_cmd_BELL,"BELL","")
      =loJC.AddCommand(_cmd_JOIN,"JOIN","Join Foxbot to any room conference")
      =loJC.AddCommand(_cmd_LEAVE,"LEAVE","Leave Foxbot from current room conference")
      =loJC.AddCommand(_cmd_SEEN,"SEEN","Locate last activity of nick")
*      =loJC.AddCommand(_cmd_READOPTIONS,"READ OPTIONS","Read options")

      =loJC.AddCommand(_cmd_HELP_CUI,"HELP CUI","")
      =loJC.AddCommand(_cmd_HELP_LUI,"HELP LUI","")
      =loJC.AddCommand(_cmd_HELP_RESTART,"HELP RESTART","")
      =loJC.AddCommand(_cmd_HELP_UNLOAD,"HELP UNLOAD","")
      =loJC.AddCommand(_cmd_HELP_SUSP,"HELP SUSP","")
      =loJC.AddCommand(_cmd_HELP_XING,"HELP ?ING","")
      =loJC.AddCommand(_cmd_HELP_BELL,"HELP BELL","")
      =loJC.AddCommand(_cmd_HELP_JOIN,"HELP JOIN","")
      =loJC.AddCommand(_cmd_HELP_LEAVE,"HELP LEAVE","")
      =loJC.AddCommand(_cmd_HELP_SEEN,"HELP SEEN","")
*      =loJC.AddCommand(_cmd_HELP_READOPTIONS,"HELP READ OPTIONS","")
   ENDPROC


   PROCEDURE GetMessage(loSP)
      * Test na chybu
      IF m.loSP.oJCP.nError>0
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL loMsg,loSers,lii,lcPom,loSer,lcData,liXID,liDSID,liMax
      liDSID=m.This.DatasessionID

      * Nyn otestuj, zda tam jsou pkazy
      IF !m.loSP.ParseCommand()
         IF LEFT(LTRIM(m.loSP.cBody),3)=":-p"
*            m.loSP.oJC.AddSpy(@loSP,_cmd_xxxxx,0,"","")

            loMsg=CREATEOBJECT("_jbmessage")
            loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
            loMsg.To=m.loSP.ReplyTo && Pjemce
            loMsg.From=m.loSP.ReplyFrom && Odeslatel

            loMsg.Body=IIF(EMPTY(m.loSP.Nick),"",m.loSP.Nick+[, ])+"Vyser si voko..."
            IF !m.loSP.oJC.GetSilentMode(m.loSP.RIDJID,m.This.Name)
               m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
            ENDIF
            RETURN _Serv_Run_Processed
         ENDIF

         RETURN _Serv_Run_Next
      ENDIF


      DO CASE
         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="CUI"
              m.loSp.oJC.AddSpy(@loSP,_cmd_CUI,0,"","")
              _Screen.ActiveForm.Release()
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="LUI"
              m.loSp.oJC.AddSpy(@loSP,_cmd_LUI,0,"","")
              DO FORM jbusr with m.loSP.oJC
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="RESTART"
              m.loSp.oJC.AddSpy(@loSP,_cmd_RESTART,0,"","")
              m.loSP.oJC.Restart()
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="UNLOAD"
              m.loSp.oJC.AddSpy(@loSP,_cmd_UNLOAD,0,"","")
              m.loSP.oJC.Disconnect()
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="SUSP"
              m.loSp.oJC.AddSpy(@loSP,_cmd_SUSP,0,"","")
              SUSP
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND LIKE("?ING",LEFT(m.loSP.aUWords(1),4))
              m.loSp.oJC.AddSpy(@loSP,_cmd_XING,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce

              loMsg.Body=m.loSP.Nick+STRTRAN("... &#;ong, &#;ong, &#;ong...","&#;",LEFT(m.loSP.aWords(1),1))
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed
	
         CASE m.loSP.aUWords(1)=="BELL" AND m.loSP.iWords=2
              m.loSp.oJC.AddSpy(@loSP,_cmd_SET_DECS,0,m.loSP.aWords(2),"")
              lcPom=m.loSP.aWords(2)+IIF(AT(".",m.loSP.aWords(2))=0,".wav","")
              sndPlaySoundA(m.This.MainPath+"sounds\"+m.lcPom,1)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="JOIN"
              m.loSp.oJC.AddSpy(@loSP,_cmd_JOIN,0,m.loSP.aWords(2),"")
              m.loSP.oJC.JoinToConf(m.loSP.aWords(2),m.loSP.oJC.DefNick)
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="LEAVE" AND m.loSP.Type=_jbm_GroupChat
              m.loSp.oJC.AddSpy(@loSP,_cmd_LEAVE,0,m.loSP.aWords(2),"")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel

              loMsg.Body="Chi, chi. I'm free..."
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              m.loSP.oJC.LeaveFromConf(m.loSP.Conf,m.loSP.oJC.DefNick)
              RETURN _Serv_Run_Processed


         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="SEEN"
              m.loSp.oJC.AddSpy(@loSP,_cmd_SEEN,0,m.loSP.aWords(2),"")
              *!seen pinky@njs.netlab.cz -> <presence from="gorila@dione.zcu.cz" to="pinky@njs.netlab.cz" type="probe" />
              *!seen pinky               -> najdi posledn aktivitu v mstnosti
              IF AT("@",m.loSP.aWords(2))>0
                 * Odeli prezenci
                 lcData=[<presence from="]+m.loSP.oJC.User+"@"+m.loSP.oJC.Server+[" to="]+m.loSP.aWords(2)+[" type="probe" />]
                 m.loSP.oJC.SendData(@m.lcData,0)
                 * A zaregistruj ji
                 m.loSP.oJC.AddEvent(_JC_E_pr,m.loSP.aWords(2),m.loSP.oJCP.oXML.XML)
              ELSE
                 loHistory=m.loSP.oJC.Services.GetService("HISTORY")
                 IF ISNULL(m.loHistory) OR m.loHistory.State#_Serv_Start_Running
                    RETURN _Serv_Run_Next
                 ENDIF

                 liXID=m.loSP.oJC.GetIDJID(m.loSP.Conf+"/"+m.loSP.aWords(2))
                 SET DATASESSION TO m.loHistory.DatasessionID
                 SELE (m.loHistory.AMSG)
                 SET ORDER TO "XXI001"
                 SET KEY TO (BINTOC(m.liXID))
                 GO BOTTOM

                 loMsg=CREATEOBJECT("_jbmessage")
                 loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
                 loMsg.To=m.loSP.ReplyTo && Pjemce
                 loMsg.From=m.loSP.ReplyFrom && Odeslatel

                 loMsg.Body=IIF(EOF(),"Unknown nick "+m.loSP.aWords(2),;
                            "The last activity: "+DT2CL(DATETIME()-XX001))
                 SET ORDER TO "XXI000"
                 SET DATASESSION TO liDSID

                 m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              ENDIF
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="READ" AND m.loSP.aUWords(2)=="OPTIONS"
              m.loSp.oJC.AddSpy(@loSP,_cmd_READOPTIONS,0,"","")
              m.loSP.oJC._ReadOptions()
              RETURN _Serv_Run_Processed

         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="HELP"
              DO CASE
                 CASE m.loSP.aUWords(2)=="JOIN"
                      liXX400I=_cmd_HELP_JOIN
                      lcData=[Join Foxbot to any room conference]+CRLF+;
                             [!JOIN  room]+CRLF+CRLF+;
                             [ Room - any room conference]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !join hauze@conf.netlab.cz]

                      lcHTML=[<span style="font-weight: bold;">Join Foxbot to any room conference<br />]+;
                             [!JOIN  room</span><br /><br />]+;
                             [ Room - any room conference<br /><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !join hauze@conf.netlab.cz]

                 CASE m.loSP.aUWords(2)=="LEAVE"
                      liXX400I=_cmd_HELP_LEAVE
                      lcData=[Leave Foxbot from current room conference]+CRLF+;
                             [!LEAVE]+CRLF+CRLF+;
                             [ Examples:]+CRLF+;
                             [ !leave]

                      lcHTML=[<span style="font-weight: bold;">Leave Foxbot from current room conference<br />]+;
                             [!LEAVE</span><br />]+;
                             [ <span style="font-style: italic;">Examples:</span><br />]+;
                             [ !leave]

                CASE m.loSP.aUWords(2)=="SEEN"
                     liXX400I=_cmd_HELP_SEEN
                     lcData=[Locate last activity of nick]+CRLF+;
                            [!SEEN nick]+CRLF+CRLF+;
                            [ nick - Jabber conference's nick]+CRLF+CRLF+;
                            [ Examples:]+CRLF+;
                            [ !seen Tvrdiaak]

                     lcHTML=[<span style="font-weight: bold;">Locate last activity of nick<br />]+;
                            [!SEEN nick</span><br />]+;
                            [ nick - Jabber conference's nick<br /><br />]+;
                            [ <span style="font-style: italic;">Examples:</span><br />]+;
                            [ !seen Tvrdiaak]
                 
                 OTHERWISE
                     RETURN _Serv_Run_Free

              ENDCASE

              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel

              loMsg.Body=lcData
              loMsg.HTML=lcHTML
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed

         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC



   PROCEDURE GetPresence(loSP)

*!*	      * Test na chybu
*!*	      IF m.loSP.oJCP.nError>0
*!*	         RETURN _Serv_Run_Next
*!*	      ENDIF

      LOCAL loMsg,liType,lcType,loXML2,loXXX,lcPom

      IF m.loSP.oJCP.Status=_JC_P_Trackly
         loXML2=m.loSP.oJCP.oTracklyXML
         lcData=m.loSP.From+['s status: ]
         lcType=NVL(m.loXML2.documentElement.GetAttribute("type"),"")
         liType=IIF(lcType=="groupchat",_jbm_GroupChat,IIF(lcType=="chat",_jbm_Chat,_jbm_Normal))

         loXXX=m.loSP.oJCP.oXML.documentElement.selectNodes('status') && Vyber objekty
         lcPom=IIF(m.loXXX.length=0,"",m.loXXX.Item(0).text)

         loMsg=CREATEOBJECT("_jbmessage")
         loMsg.To=m.loSP.Conf && Pjemce
         loMsg.From=m.loSP.ReplyFrom && Odeslatel
         loMsg.Body=m.lcData+m.lcPom
         m.loSP.oJC.SendMessage(@m.loMsg,m.liType,0)
      ENDIF
      RETURN _Serv_Run_Free
   ENDPROC

ENDDEFINE
