#INCLUDE "threads.h"
**********************************************
* Paraleln programovn
***********************************************

*!*    - timer, matice pro objekty td _vfp_thread (datasession???)
*!*    - tda _vfp_thread m matici acommands ve kter jsou uloeny objekty tdy _commad 
*!*        - m metodu pro vrcen pkazu(objetu) dle indexu
*!*        - ma vlasnost urujc posledn probhl pkaz
*!*        - m metodu pro vbr pkazu a jeho sputn, 0 - stle b, 1 - pkaz dokonen
*!*            - pokud je vrcena jedna, inkrementuje se ta probhlch pkaz


DEFINE CLASS _tmrThreads AS timer && Timer na spoutn thread
   Name="_tmrThreads"
   DIMENSION aThreads(1)
   iThreads=0
   oThreads=.NULL. && Konteiner thread
   Enabled=.F.
   Interval=500

   PROCEDURE Timer()
      LOCAL lii
      lii=1
      DO WHILE lii<=This.iThreads
         IF INLIST(This.aThreads(m.lii).RunCommand(),_thr_End,_thr_Failed) && Ukonen thread
            * Pak jej odstra
            This.aThreads(m.lii)=.NULL. && Uvolni thread
            =ADEL(This.aThreads,m.lii) && Sma buku
            This.iThreads=This.iThreads-1 && Dekrementuj ta
         ELSE
            lii=lii+1
         ENDIF
      ENDDO
      This.Enabled=This.iThreads>0
   ENDPROC

   PROCEDURE AddThread(loThread) && Pid thread do seznamu
      This.iThreads=This.iThreads+1
      IF This.iThreads=ALEN(This.aThreads)
         DIMENSION This.aThreads(This.iThreads+50)
      ENDIF
      This.aThreads(This.iThreads)=loThread
      This.Enabled=This.iThreads>0
   ENDPROC
ENDDEFINE




DEFINE CLASS _Thread AS custom && Vlastn thread
   Name="_Thread"

   Index=0 && Index probhlho pkazu
   oSession=.NULL.
   _cmdFailed="" && Nzev pkazu, kter se zavol kdy nco sele
   ReRun=0 && Index pkazu pro optovn sputn

   PROCEDURE Init()
      This.oSession=CREATEOBJECT("session")
      SET DATASESSION TO (This.oSession.DataSessionID)
   ENDPROC

   PROCEDURE RunCommand()
      LOCAL liRet,locmd
      IF This.Index>=This.ControlCount
          RETURN _thr_End
      ENDIF
      locmd=This.Controls(This.Index+1)
   
      * Ignoruj pkaz na zpracovan chyb
      IF locmd.iFailed=1
         This.Index=This.Index+1
         RETURN _thr_NextCommand
      ENDIF

      liRet=locmd.RunCommand()
      DO CASE
         CASE liRet=_cmd_End && Pkaz ukonen
             IF This.Index+1=This.ControlCount
                * Indikace konce threadu
                liRet=_thr_End
             ELSE
                liRet=_thr_NextCommand
                This.Index=This.Index+1
             ENDIF

         CASE liRet=_cmd_Running && Pkaz pokrauje
              liRet=_thr_CurrentCommand

         CASE liRet=_cmd_Failed && Pkaz selhal
              =IIF(PEMSTATUS(This,This._cmdFailed,5),EVALUATE("This."+This._cmdFailed+".RunCommand(locmd)"),.T.)
              liRet=_thr_Failed

         CASE liRet=_cmd_ReRun && Pkaz ukonen a zrove je zpracovn pesunoto na dal
              This.Index=This.ReRun-1 && Index na pedchoz pkaz
              This.ReRun=0
              liRet=_thr_NextCommand

      ENDCASE
      RETURN liRet
   ENDPROC

   PROCEDURE AddCommand(lcClass)
      * lcClass - nzev tdy pkazu
      This.AddObject("_"+LTRIM(STR(This.ControlCount+1)),lcClass)
   ENDPROC


   PROCEDURE GetCommandIndex(lcName)
      * lcNAme - nzev pkazu
      LOCAL lii
      FOR lii=1 TO This.ControlCount
          IF LOWER(This.Controls(lii).Name)==LOWER(lcName)
             EXIT
          ENDIF
      NEXT
      RETURN IIF(lii>This.ControlCount,0,lii)
   ENDPROC

ENDDEFINE



DEFINE CLASS _Command AS Custom && Pkaz
   Name="_Command"
   iFailed=0

   PROCEDURE RunCommand()
      RETURN _cmd_End
   ENDPROC
ENDDEFINE