#INCLUDE "..\..\jabber.h"
#INCLUDE "..\..\vfpbot.h"
#INCLUDE "info.h"

PROCEDURE GetInterface(loInterface)
loInterface=CREATEOBJECT("_info_service")
RETURN .T.


**************************************************
DEFINE CLASS _info_service AS _service
   Name="_info_service"


   PROCEDURE AfterInit(loJC)
      =loJC.AddCommand(_cmd_INFO,"INFO","Show robot's info")

      =loJC.AddCommand(_cmd_HELP_INFO,"HELP INFO","")
   ENDPROC

   PROCEDURE GetMessage(loSP)
      * Test na chybu
      IF m.loSP.oJCP.nError>0
         RETURN _Serv_Run_Next
      ENDIF

      * Nyn otestuj, zda tam jsou pkazy
      IF !m.loSP.ParseCommand()
         RETURN _Serv_Run_Next
      ENDIF

      LOCAL loMsg,lcData,lcHTML,lcExtra

      DO CASE

         CASE m.loSP.iWords=1 AND m.loSP.aUWords(1)=="INFO"
              m.loSP.oJC.AddSpy(@loSP,_cmd_INFO,0,"","")
              lcData="Jabber client: VFP Jabber client, version: "+m.loSP.oJC.Version+;
                     " (Portions of this software based on SocketWrench"+STRCONV("",9)+", licensed from Catalyst Development Corporation)"+CRLF+;
                     "(CryptPak.vcx by Milan Kosina and CryptPak.dll by Markus Hahn)"+CRLF+CRLF+;
                     "Bot: VFP Robot, version: "+m.loSP.oJC.BotVersion+CRLF+;
                     "Author: gorila@dione.zcu.cz"+CRLF+CRLF+;
                     "UI"+CRLF+;
                     "E.L.I.Z.A. - Elektronika 9/90, "+STRCONV("Ing. Frantiek ervenka",9)+CRLF+;
                     "(by Joseph Weinzenbaum at MIT in mid 60s.)"+CRLF+CRLF+;
                     "Dictionaries"+CRLF+;
                     "GNU/FDL Czech dictionary, English to Czech (http://slovnik.zcu.cz/)"+CRLF+;
                     "GNU/FDL Czech dictionary, German to Czech (http://slovnik.zcu.cz/)"

              lcExtra=[<x xmlns='jabber:x:oob'><url>http://slovnik.zcu.cz/</url><desc>GNU/FDL Czech dictionary, English to Czech and German to Czech</desc></x>]+;
                      [<x xmlns='jabber:x:roster'>]+;
                      [<item jid='gorila@dione.zcu.cz' name='gorila'><group/></item>]+;
                      [<item jid='FoxBot@njs.netlab.cz' name='FoxBot'><group/></item>]+;
                      [</x>]

              lcHTML=[<span style="font-weight: bold;">Jabber client:</span> VFP Jabber client, <span style="font-style: italic;">version</span>: ]+m.loSP.oJC.Version+;
                     " (Portions of this software based on SocketWrench"+STRCONV("",9)+", licensed from Catalyst Development Corporation)<br />"+;
                     "(CryptPak.vcx by Milan Kosina and CryptPak.dll by Markus Hahn)<br /><br />"+;
                     [<span style="font-weight: bold;">Bot:</span> VFP Robot, <span style="font-style: italic;">version</span>: ]+m.loSP.oJC.BotVersion+"<br />"+;
                     [<span style="font-weight: bold;">Author:</span> gorila@dione.zcu.cz<br /><br />]+;
                     [<span style="font-weight: bold;">UI</span><br />]+;
                     [ E.L.I.Z.A. - Elektronika 9/90, ]+STRCONV("Ing. Frantiek ervenka",9)+;
                     [ (by Joseph Weinzenbaum at MIT in mid 60s.)<br /><br />]+;
                     [<span style="font-weight: bold;">Dictionaries</span><br />]+;
                     [GNU/FDL Czech dictionary, English to Czech (http://slovnik.zcu.cz/)<br />]+;
                     [GNU/FDL Czech dictionary, German to Czech (http://slovnik.zcu.cz/)]

              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel

              loMsg.Body=m.lcData
              loMsg.HTML=m.lcHTML
              loMsg.Extra=m.lcExtra
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed


         CASE m.loSP.iWords=2 AND m.loSP.aUWords(1)=="HELP"
              DO CASE
                 CASE m.loSP.aUWords(2)=="INFO"
                      liXX400I=_cmd_HELP_INFO
                      lcData=[Show robot's info]+CRLF+;
                             [!INFO]

                      lcHTML=[<span style="font-weight: bold;">Show robot's info<br />]+;
                             [!INFO</span>]
                 
                 OTHERWISE
                     RETURN _Serv_Run_Free

              ENDCASE

              m.loSp.oJC.AddSpy(@loSP,m.liXX400I,0,"","")
              loMsg=CREATEOBJECT("_jbmessage")
              loMsg.ID=m.loSP.oJCP.ID && Pevezmi ID
              loMsg.To=m.loSP.ReplyTo && Pjemce
              loMsg.From=m.loSP.ReplyFrom && Odeslatel

              loMsg.Body=lcData
              loMsg.HTML=lcHTML
              m.loSP.oJC.SendMessage(@m.loMsg,m.loSP.Type,0)
              RETURN _Serv_Run_Processed

         OTHERWISE
              RETURN _Serv_Run_Free
      ENDCASE
   ENDPROC

ENDDEFINE
